/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/


package lsagpi;

import java.util.StringTokenizer;

/**
 * Preprocesador que elemina los comentarios del fichero fuente.
 * @author Miguel Angel Pescador Santirso
 */
public class Preprocesador {
    String retorno;
    /**
     * Contructor del preprocesador
     * @param fuente String con el fichero fuente.
     */
    public Preprocesador(String fuente){
        StringTokenizer fuente_tok=new StringTokenizer(fuente,"\n",true);
        String codigo;
        retorno=new String("");
        while (fuente_tok.hasMoreTokens())
		{
            codigo=fuente_tok.nextToken();
            
            if(codigo.indexOf("//")!=-1 || codigo.indexOf("/*")!=-1){
                if(codigo.indexOf("//")!=-1){
                    retorno+=codigo.substring(0,codigo.indexOf("//"))+"\n";
                }
                if(codigo.indexOf("/*")!=-1){
                    if(codigo.indexOf("*/")!=-1){
                        retorno+=codigo.substring(0,codigo.indexOf("/*"))+"\n";
                    }else{
                        retorno+=codigo.substring(0,codigo.indexOf("/*"))+"\n";
                        while(codigo.indexOf("*/")==-1){
                            codigo=fuente_tok.nextToken();
                        }
                        retorno+=codigo.substring(codigo.indexOf("*/"),codigo.length());
                    }
                }
            }else{
               retorno+=codigo;
            }
        }
        //System.out.println(retorno);
       }
       /**
        * Devuelve la cadena sin comentarios.
        * @return String fichero fuente sin comentarios.
        */
       public String getRetorno(){
           return retorno;
       }
}
